#include "Nibble_arr.h"

unsigned char Nibble_arr::extractHighNibble(unsigned char nibblePair) {
	return (nibblePair & 0xF0)>>4;
}
unsigned char Nibble_arr::extractLowNibble(unsigned char nibblePair) {
	return (nibblePair & 0x0F);
}
unsigned char Nibble_arr::setLowNibble(unsigned char val, unsigned char nibblePair) {
	unsigned char nibblePairNoLower = nibblePair & 0xF0;
	return nibblePairNoLower | (val & 0xF);
}
unsigned char Nibble_arr::setHighNibble(unsigned char val, unsigned char nibblePair) {
	unsigned char nibblePairNoHigher = nibblePair & 0x0F;
	return nibblePairNoHigher | ((val & 0xF)<<4);
}

unsigned char Nibble_arr::get(unsigned char x, unsigned char y) {
	if (y%2==0) {
		return extractLowNibble(array[x][y/2]);
	} else {
		return extractHighNibble(array[x][y/2]);
	}
}

void Nibble_arr::increment(unsigned char x, unsigned char y) {
	if (y%2==0)
	{
		unsigned char tmp = extractLowNibble(array[x][y/2]);
		if (tmp<0xF)
		{
			tmp = setLowNibble(tmp+1, array[x][y/2]);
			array[x][y/2]=tmp;
		}
	} else {
		unsigned char tmp = extractHighNibble(array[x][y/2]);
		if (tmp<0xF)
		{
			tmp = setHighNibble(tmp+1, array[x][y/2]);
			array[x][y/2]=tmp;
		}
	}
}

void Nibble_arr::decrement(unsigned char x, unsigned char y) {
	if (y%2==0)
	{
		unsigned char tmp = extractLowNibble(array[x][y/2]);
		if (tmp>0)
		{
			tmp = setLowNibble(tmp-1, array[x][y/2]);
			array[x][y/2]=tmp;
		}
		
	} else {
		unsigned char tmp = extractHighNibble(array[x][y/2]);
		if (tmp>0)
		{
			char tmp = setHighNibble(tmp-1, array[x][y/2]);
			array[x][y/2]=tmp;
		}
	}
}

void Nibble_arr::set(unsigned char val, unsigned char x, unsigned char y) {
	if (y%2==0)
	{
    array[x][y/2] = setLowNibble(val, array[x][y/2]);
	} else {
		array[x][y/2] = setHighNibble(val, array[x][y/2]);
	}
}